package com.future.common.utils;


import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

/**
 * 短编码生成工具可用于验证码,邀请码生成
 */
public class ShortCodeUtil {

    public static void main(String[] args) {
        Map<String, Long> map = new HashMap<>();
        long starttime = new Date().getTime();
        System.err.println();
        for (int i = 0; i < 100000; i++) {
            String commonRandomCode = generateShortUuid();
            Long count = map.get(commonRandomCode);
            if (null != count) {
                count = count + 1L;
                map.put(commonRandomCode, count);
            } else {
                map.put(commonRandomCode, 1L);
            }
            System.err.println(commonRandomCode);

        }

        for (String s : map.keySet()) {
            Long count = map.get(s);
            if (count > 1) {
                System.err.println(s + "---" + count);
            } else {
                //System.err.println(s + "---" + count);
            }
        }
        long endtime = new Date().getTime();
        long diff = endtime - starttime;
        long time = diff / 1000;
        System.err.println(time + ":秒");
    }

    public static String[] chars = new String[]{"a", "b", "c", "d", "e", "f",
            "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s",
            "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5",
            "6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "G", "H", "I",
            "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V",
            "W", "X", "Y", "Z"};


    public static String generateShortUuid() {
        StringBuffer shortBuffer = new StringBuffer();
        String uuid = UUID.randomUUID().toString().replace("-", "");
        for (int i = 0; i < 8; i++) {
            String str = uuid.substring(i * 4, i * 4 + 4);
            int x = Integer.parseInt(str, 16);
            shortBuffer.append(chars[x % 0x3E]);
        }
        return shortBuffer.toString();

    }
}




