package com.future.common.validate.annotation;


import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;

public class NullSizeImpl implements ConstraintValidator<NullSize, String> {

    private String checkStr = "";

    private int min = 0;

    private int max = 0;


    public void initialize(NullSize constraintAnnotation) {
        this.checkStr = constraintAnnotation.message();
        this.min = constraintAnnotation.min();
        this.max = constraintAnnotation.max();
    }


    public boolean isValid(String s, ConstraintValidatorContext constraintValidatorContext) {

        if (s == null || s == "") {
            return true;
        } else {
            int length = s.length();
            if (length <= max && length >= min) {
                return true;
            } else {
                return false;
            }

        }
    }
}
